## bareos 23.1.6~pre1.e06a5555f

=== CMakeLists.txt ===
#   BAREOS® - Backup Archiving REcovery Open Sourced
#
#   Copyright (C) 2019-2024 Bareos GmbH & Co. KG
#
#   This program is Free Software; you can redistribute it and/or
#   modify it under the terms of version three of the GNU Affero General Public
#   License as published by the Free Software Foundation and included
#   in the file LICENSE.
#
#   This program is distributed in the hope that it will be useful, but
#   WITHOUT ANY WARRANTY; without even the implied warranty of
#   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
#   Affero General Public License for more details.
#
#   You should have received a copy of the GNU Affero General Public License
#   along with this program; if not, write to the Free Software
#   Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA
#   02110-1301, USA.
message("Entering ${CMAKE_CURRENT_SOURCE_DIR}")

cmake_minimum_required(VERSION 3.17)
cmake_policy(VERSION 3.17...3.19)

project(bareos NONE)
set(CMAKE_POSITION_INDEPENDENT_CODE ON)

list(APPEND CMAKE_MODULE_PATH "${CMAKE_CURRENT_SOURCE_DIR}/cmake")
list(APPEND CMAKE_MODULE_PATH "${CMAKE_CURRENT_SOURCE_DIR}/core/cmake")

add_custom_target(
  uninstall "${CMAKE_COMMAND}" -P
            "${CMAKE_CURRENT_SOURCE_DIR}/cmake/uninstall.cmake"
)
set(default_build_type "Debug")

include(CMakePrintHelpers)
find_package(Git)
include(BareosVersionFromGit)
include(BareosExtractVersionInfo)
include(BareosGetDistInfo)
include(RemoveNDebugFlag)
set(BUILDNAME
    "${BAREOS_FULL_VERSION}"
    CACHE STRING "site name variable for CDash"
)
set(SITE
    "${CMAKE_SYSTEM_NAME}-${DISTVER}-${CMAKE_HOST_SYSTEM_PROCESSOR}"
    CACHE STRING "build name variable for CDash"
)
# enable "make test"
enable_testing()
set(CMAKE_CTEST_COMMAND ctest -V)
include(CTest)

option(BUILD_UNIVERSAL_CLIENT
       "Override build-options to produce a limited, but universal client" OFF
)
if(BUILD_UNIVERSAL_CLIENT)
  if(CMAKE_VERSION VERSION_LESS 3.18.0)
    message(
      FATAL_ERROR "Building the universal client requires at least CMake 3.18"
    )
  endif()
  set(ENABLE_PYTHON
      OFF
      CACHE BOOL "" FORCE
  )
  set(ENABLE_GFAPI_FD
      OFF
      CACHE BOOL "" FORCE
  )
  set(ENABLE_JANSSON
      OFF
      CACHE BOOL "" FORCE
  )
  set(ENABLE_LZO
      OFF
      CACHE BOOL "" FORCE
  )
  set(ENABLE_CAPABILITY
      OFF
      CACHE BOOL "" FORCE
  )
  set(ENABLE_BCONSOLE
      OFF
      CACHE BOOL "" FORCE
  )
  set(ENABLE_STATIC_RUNTIME_LIBS
      ON
      CACHE BOOL "" FORCE
  )
  set(client-only ON)
endif()

option(ENABLE_WEBUI "Build with WEBUI" ON)
option(docs-only "Build only the documentation" OFF)
option(docs-build-json "Update the configuration schema JSON files" OFF)

if(docs-build-json)
  # check for wrong combinations of build flags
  if(docs-only)
    message(
      FATAL_ERROR
        "\n\"docs-build-json\" needs bareos-executables and cannot be combined with \"docs-only\""
    )
  endif()
  if(NOT traymonitor)
    message(
      FATAL_ERROR
        "\n\"docs-build-json\" needs the traymonitor executable: add \"-Dtraymonitor=yes\""
    )
  endif()
endif()

if(docs-only)
  set(BUILD_BAREOS_BINARIES no)
else()
  set(BUILD_BAREOS_BINARIES yes)
endif()

if(NOT hostname)
  site_name(hostname)
endif()

if(BUILD_BAREOS_BINARIES)
  project(bareos C CXX)
  include(BareosCpmPackages)
  if(NOT CMAKE_BUILD_TYPE
     AND NOT CMAKE_C_FLAGS
     AND NOT CMAKE_CXX_FLAGS
  )
    set(CMAKE_BUILD_TYPE "RelWithDebInfo")
  endif()
  add_subdirectory(third-party EXCLUDE_FROM_ALL)
  add_subdirectory(core)
  if(ENABLE_WEBUI)
    add_subdirectory(webui)
  endif()
  if(NOT client-only AND NOT ${CMAKE_SYSTEM_NAME} MATCHES "Windows")
    add_subdirectory(systemtests)
  endif()
  add_subdirectory(contrib)
endif()

if(docs
   OR docs-only
   OR docs-build-json
)
  add_subdirectory(docs/manuals)
endif()
set(SITE ${BAREOS_PLATFORM}-${DISTVER})

=== contrib/CMakeLists.txt ===
#   BAREOS® - Backup Archiving REcovery Open Sourced
#
#   Copyright (C) 2021-2021 Bareos GmbH & Co. KG
#
#   This program is Free Software; you can redistribute it and/or
#   modify it under the terms of version three of the GNU Affero General Public
#   License as published by the Free Software Foundation and included
#   in the file LICENSE.
#
#   This program is distributed in the hope that it will be useful, but
#   WITHOUT ANY WARRANTY; without even the implied warranty of
#   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
#   Affero General Public License for more details.
#
#   You should have received a copy of the GNU Affero General Public License
#   along with this program; if not, write to the Free Software
#   Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA
#   02110-1301, USA.
message("Entering ${CMAKE_CURRENT_SOURCE_DIR}")
project(bareos-contrib)

set(CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH} ${PROJECT_SOURCE_DIR}/cmake)

include(GNUInstallDirs)
include(BareosSetVariableDefaults)

add_subdirectory(fd-plugins)
if(NOT ${CMAKE_SYSTEM_NAME} MATCHES "SunOS")
  add_subdirectory(misc)
endif()
if(NOT client-only)
  add_subdirectory(dir-plugins)
endif()

=== core/CMakeLists.txt ===
#   BAREOS® - Backup Archiving REcovery Open Sourced
#
#   Copyright (C) 2017-2025 Bareos GmbH & Co. KG
#
#   This program is Free Software; you can redistribute it and/or
#   modify it under the terms of version three of the GNU Affero General Public
#   License as published by the Free Software Foundation and included
#   in the file LICENSE.
#
#   This program is distributed in the hope that it will be useful, but
#   WITHOUT ANY WARRANTY; without even the implied warranty of
#   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
#   Affero General Public License for more details.
#
#   You should have received a copy of the GNU Affero General Public License
#   along with this program; if not, write to the Free Software
#   Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA
#   02110-1301, USA.
message("Entering ${CMAKE_CURRENT_SOURCE_DIR}")
project(bareos C CXX)

if(CMAKE_SOURCE_DIR STREQUAL CMAKE_CURRENT_SOURCE_DIR)
  message(
    FATAL_ERROR
      "Building from bareos/core/ is not supported anymore. Use bareos/ instead"
  )
endif()

# disable in-source builds
if("${PROJECT_SOURCE_DIR}" STREQUAL "${PROJECT_BINARY_DIR}")
  message(FATAL_ERROR "In-source builds are not allowed.")
endif()

set(CMAKE_INSTALL_DEFAULT_COMPONENT_NAME common)

include(GNUInstallDirs)

find_program(CCACHE_FOUND ccache)
if(CCACHE_FOUND)
  set_property(GLOBAL PROPERTY RULE_LAUNCH_COMPILE ccache)
  set_property(GLOBAL PROPERTY RULE_LAUNCH_LINK ccache)
endif(CCACHE_FOUND)

# switch on CXX 17 Support
#
set(CMAKE_CXX_STANDARD 17)
set(CMAKE_CXX_STANDARD_REQUIRED ON)

# enable PIC/PIE by default
include(CheckPIESupported)
check_pie_supported()
set(CMAKE_POSITION_INDEPENDENT_CODE ON)

option(ENABLE_SANITIZERS "Build with ASan/LSan/UBSan enabled" OFF)
if(ENABLE_SANITIZERS)
  if(CMAKE_CXX_COMPILER_ID STREQUAL "GNU")
    set(CMAKE_CXX_FLAGS
        "${CMAKE_CXX_FLAGS} -fsanitize=undefined -fsanitize=address -fno-sanitize-recover"
    )
    set(CMAKE_C_FLAGS
        "${CMAKE_C_FLAGS} -fsanitize=undefined -fsanitize=address -fno-sanitize-recover"
    )
  else()
    message(
      FATAL_ERROR
        "Cannot (yet) compile with sanitizers on ${CMAKE_C_COMPILER_ID}"
    )
  endif()
endif()

option(ENABLE_THREAD_SANITIZERS "Build with TSan enabled" OFF)
if(ENABLE_THREAD_SANITIZERS)
  if(CMAKE_CXX_COMPILER_ID STREQUAL "GNU")
    set(CMAKE_CXX_FLAGS
        "${CMAKE_CXX_FLAGS} -fsanitize=thread -fno-sanitize-recover"
    )
    set(CMAKE_C_FLAGS
        "${CMAKE_C_FLAGS} -fsanitize=thread -fno-sanitize-recover"
    )

    add_compile_definitions(BAREOS_THREAD_SANITIZER=1)
  elseif(CMAKE_CXX_COMPILER_ID STREQUAL "Clang")
    set(CMAKE_CXX_FLAGS
        "${CMAKE_CXX_FLAGS} -fsanitize=thread -fno-sanitize-recover"
    )
    set(CMAKE_C_FLAGS
        "${CMAKE_C_FLAGS} -fsanitize=thread -fno-sanitize-recover"
    )
    add_compile_definitions(BAREOS_THREAD_SANITIZER=1)
  elseif(CMAKE_CXX_COMPILER_ID STREQUAL "MSVC")
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} /fsanitize=thread")
    set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} /fsanitize=thread")
    add_compile_definitions(BAREOS_THREAD_SANITIZER=1)
  else()
    message(
      FATAL_ERROR
        "Cannot (yet) compile with sanitizers on ${CMAKE_C_COMPILER_ID}"
    )
  endif()
endif()

if(ENABLE_THREAD_SANITIZERS AND ENABLE_SANITIZERS)
  message(
    WARNING
      "enabling both thread sanitizer and address sanitizer is not supported"
  )
endif()

option(ENABLE_STATIC_RUNTIME_LIBS "Link C and C++ runtime libraries statically"
       OFF
)
if(ENABLE_STATIC_RUNTIME_LIBS)
  if(CMAKE_CXX_COMPILER_ID STREQUAL "GNU")
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -static-libgcc -static-libstdc++")
    set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -static-libgcc")
  else()
    message(
      FATAL_ERROR
        "Cannot (yet) do static runtime-libraries on ${CMAKE_C_COMPILER_ID}"
    )
  endif()
endif()

if(CMAKE_VERSION VERSION_GREATER_EQUAL 3.18.0)
  include(CheckLinkerFlag)
  check_linker_flag(CXX "-Wl,--as-needed" LD_SUPPORTS_AS_NEEDED)
  if(LD_SUPPORTS_AS_NEEDED AND NOT CMAKE_LINK_WHAT_YOU_USE)
    add_link_options("-Wl,--as-needed")
  endif()
endif()

include(CheckCCompilerFlag)
include(CheckCXXCompilerFlag)
check_cxx_compiler_flag(-Wsuggest-override compiler_will_suggest_override)

if(${compiler_will_suggest_override})
  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wsuggest-override")
endif()

if(NOT ${CMAKE_SYSTEM_NAME} MATCHES "SunOS")
  # make format-security issues a compiler-error
  check_cxx_compiler_flag(-Wformat compiler_format_security)
  if(${compiler_format_security})
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wformat")
  endif()
  check_cxx_compiler_flag(
    -Werror=format-security compiler_error_format_security
  )
  if(${compiler_error_format_security})
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Werror=format-security")
  endif()
endif()

option(DEBUG_PREFIX_MAP
       "remap absolute debug paths to relative if compiler supports it" ON
)
check_c_compiler_flag(
  -fdebug-prefix-map=${CMAKE_CURRENT_SOURCE_DIR}=. c_compiler_debug_prefix_map
)
check_cxx_compiler_flag(
  -fdebug-prefix-map=${CMAKE_CURRENT_SOURCE_DIR}=.
  cxx_compiler_debug_prefix_map
)
if(DEBUG_PREFIX_MAP
   AND c_compiler_debug_prefix_map
   AND cxx_compiler_debug_prefix_map
)
  set(CMAKE_C_FLAGS
      "${CMAKE_C_FLAGS} -fdebug-prefix-map=${CMAKE_CURRENT_SOURCE_DIR}=."
  )
  set(CMAKE_CXX_FLAGS
      "${CMAKE_CXX_FLAGS} -fdebug-prefix-map=${CMAKE_CURRENT_SOURCE_DIR}=."
  )
endif()

check_c_compiler_flag(
  -fmacro-prefix-map=${CMAKE_CURRENT_SOURCE_DIR}=. c_compiler_macro_prefix_map
)
check_cxx_compiler_flag(
  -fmacro-prefix-map=${CMAKE_CURRENT_SOURCE_DIR}=.
  cxx_compiler_macro_prefix_map
)
if(c_compiler_macro_prefix_map)
  set(CMAKE_C_FLAGS
      "${CMAKE_C_FLAGS} -fmacro-prefix-map=${CMAKE_CURRENT_SOURCE_DIR}=."
  )
endif()
if(cxx_compiler_macro_prefix_map)
  set(CMAKE_CXX_FLAGS
      "${CMAKE_CXX_FLAGS} -fmacro-prefix-map=${CMAKE_CURRENT_SOURCE_DIR}=."
  )
endif()

check_cxx_compiler_flag(-Winvalid-offsetof compiler_has_invalid_offsetof)
if(compiler_has_invalid_offsetof)
  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wno-invalid-offsetof")
endif()

# warn on sign-conversion include(CheckCCompilerFlag)
# CHECK_C_COMPILER_FLAG(-Wsign-conversion c_compiler_will_warn_sign_conversion)
#
# if (${c_compiler_will_warn_sign_conversion}) set (CMAKE_C_FLAGS
# "${CMAKE_C_FLAGS} -Wsign-conversion") endif()
#
# CHECK_CXX_COMPILER_FLAG(-Wsign-conversion
# cxx_compiler_will_warn_sign_conversion)
#
# if (${cxx_compiler_will_warn_sign_conversion}) set (CMAKE_CXX_FLAGS
# "${CMAKE_CXX_FLAGS} -Wsign-conversion") endif()

if(NOT ${CMAKE_SYSTEM_NAME} MATCHES "Windows")
  include_directories(/usr/include)
endif()

set(CMAKE_MODULE_PATH
    ${CMAKE_MODULE_PATH} ${PROJECT_SOURCE_DIR}/../../SOURCES
    ${PROJECT_SOURCE_DIR}/../SOURCES ${PROJECT_SOURCE_DIR}/cmake
)

set(host ${CMAKE_SYSTEM})

set(CMAKE_EXPORT_COMPILE_COMMANDS ON)

include(BareosGetDistInfo)

set(BUILDNAME
    "${BAREOS_NUMERIC_VERSION}"
    CACHE STRING "site name variable for CDash"
)
set(SITE
    "${CMAKE_SYSTEM_NAME}-${DISTVER}-${CMAKE_HOST_SYSTEM_PROCESSOR}"
    CACHE STRING "build name variable for CDash"
)
# enable "make test"
enable_testing()
set(CMAKE_CTEST_COMMAND ctest -V)
include(CTest)

if(${CMAKE_SYSTEM_NAME} MATCHES "Darwin")
  set(HAVE_DARWIN_OS 1)
  if(DEFINED ENV{HOMEBREW_PREFIX})
    set(HOMEBREW_PREFIX "$ENV{HOMEBREW_PREFIX}")
  else()
    set(HOMEBREW_PREFIX "/usr/local")
  endif()

  set(OPENSSL_ROOT_DIR ${HOMEBREW_PREFIX}/opt/openssl@3)
  set(Readline_ROOT_DIR ${HOMEBREW_PREFIX}/opt/readline)
  set(Intl_ROOT_DIR ${HOMEBREW_PREFIX}/opt/gettext)
endif()

if(${CMAKE_SYSTEM_NAME} MATCHES "Windows")
  set(MINGW_PREFIX ${CMAKE_INSTALL_PREFIX})
  set(MINGW_BINDIR "${MINGW_PREFIX}/bin")
  if(${WINDOWS_BITS} MATCHES "32")
    set(CMAKE_CROSSCOMPILING_EMULATOR wine)
    set(SITE
        "${CMAKE_SYSTEM}-32"
        CACHE STRING "build name variable for CDash"
    )
  else()
    set(CMAKE_CROSSCOMPILING_EMULATOR wine64)
    set(SITE
        "${CMAKE_SYSTEM}-64"
        CACHE STRING "build name variable for CDash"
    )
  endif()

  # search for dll.a files before .dll
  set(MINGW_LIBDIR "${MINGW_PREFIX}/lib")
  set(CMAKE_LIBRARY_PATH ${MINGW_LIBDIR})

  # set WINEPATH so that cross-compiled .exe tests find their dlls
  set(WINEPATH "Z:${MINGW_BINDIR}\\\\;")
  string(APPEND WINEPATH "Z:${CMAKE_CURRENT_BINARY_DIR}/src/lib\\\\;")
  string(APPEND WINEPATH "Z:${CMAKE_CURRENT_BINARY_DIR}/src/fastlz\\\\;")
  string(APPEND WINEPATH "Z:${CMAKE_CURRENT_BINARY_DIR}/src/findlib\\\\;")
  string(APPEND WINEPATH "Z:${CMAKE_CURRENT_BINARY_DIR}/src/stored\\\\;")
  string(APPEND WINEPATH "Z:${CMAKE_CURRENT_BINARY_DIR}/src/cats\\\\;")

  message(${WINEPATH})
  # replace slash with backslash everywhere
  string(REPLACE "/" "\\" WINEPATH ${WINEPATH})
  # MESSAGE(FATAL_ERROR ${WINEPATH})

  set(ENV{WINEPATH} ${WINEPATH})

endif()

include(BareosFindAllLibraries)
include(BareosFindPrograms)

if(NOT ${OPENSSL_FOUND})
  message(FATAL_ERROR "FATAL ERROR: OpenSSL is required but was not found.")
endif()

if(coverage)
  set(COVERAGE_COMPILER_FLAGS
      "-g -O0 --coverage -fprofile-arcs -ftest-coverage"
      CACHE INTERNAL ""
  )
  message(
    STATUS
      "coverage requested, adding COVERAGE_COMPILER_FLAGS : ${COVERAGE_COMPILER_FLAGS}"
  )
  set(CMAKE_BUILD_TYPE Debug)
  if(CMAKE_C_COMPILER_ID STREQUAL "GNU")
    link_libraries(gcov)
  else()
    set(CMAKE_EXE_LINKER_FLAGS "${CMAKE_EXE_LINKER_FLAGS} --coverage")
  endif()
  set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} ${COVERAGE_COMPILER_FLAGS}")
  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} ${COVERAGE_COMPILER_FLAGS}")

  add_custom_target(
    cov-clean
    COMMENT "Cleaning gcda files from ${CMAKE_BINARY_DIR} and report."
    COMMAND find "${CMAKE_BINARY_DIR}" -name '*.gcda' -delete
    COMMAND "${CMAKE_COMMAND}" -E rm -rf "${CMAKE_BINARY_DIR}/coverage"
  )

  find_program(PROGRAM_GCOVR gcovr)
  if(PROGRAM_GCOVR)
    add_custom_target(
      cov-report
      COMMENT "Creating HTML coverage report in ${CMAKE_BINARY_DIR}/coverage"
      # avoid irritating gcov error by removing a broken gcno file
      COMMAND
        "${CMAKE_COMMAND}" -E rm -f
        "${CMAKE_BINARY_DIR}/core/src/droplet/libdroplet/CMakeFiles/droplet.dir/src/getdate.c.gcno"
      COMMAND "${CMAKE_COMMAND}" -E make_directory
              "${CMAKE_BINARY_DIR}/coverage"
      COMMAND
        "${PROGRAM_GCOVR}" --html-details
        "${CMAKE_BINARY_DIR}/coverage/index.html" --root "${CMAKE_SOURCE_DIR}"
        --filter "${CMAKE_SOURCE_DIR}" --filter "${CMAKE_BINARY_DIR}"
        "${CMAKE_BINARY_DIR}"
    )
  else()
    add_custom_target(
      cov-report
      COMMAND
        "${CMAKE_COMMAND}" -E echo
        "WARNING: gcovr binary not found, cannot create HTML coverage report"
    )
  endif()
endif()

if(${CMAKE_SYSTEM_NAME} MATCHES "Linux")
  set(HAVE_LINUX_OS 1)
  include_directories(/usr/include/tirpc)
endif()

if(${CMAKE_SYSTEM_NAME} MATCHES "SunOS")
  set(HAVE_SUN_OS 1)
  link_libraries(nsl socket curses sec)

  if(${CMAKE_C_COMPILER_ID} MATCHES SunPro)
    include_directories(/usr/local/include)
    link_directories(/usr/local/lib)

    set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -m64")
  endif()

  if(${CMAKE_CXX_COMPILER_ID} MATCHES SunPro)
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -m64")
  endif()
endif()

if(${CMAKE_SYSTEM_NAME} MATCHES "FreeBSD")
  set(HAVE_FREEBSD_OS 1)
  include_directories(SYSTEM /usr/local/include)
  link_directories(/usr/local/lib)
  link_libraries(intl)
  check_cxx_compiler_flag(
    -Wunused-but-set-variable compiler_will_warn_of_unused_but_set_variable
  )
endif()

if(${CMAKE_SYSTEM_NAME} MATCHES "Darwin")
  # set(CMAKE_INCLUDE_PATH  "${OPENSSL_INCLUDE_DIR}:${CMAKE_INCLUDE_PATH}")
  set(CMAKE_INCLUDE_PATH "${HOMEBREW_PREFIX}/opt/:${CMAKE_INCLUDE_PATH}")
  link_directories(${HOMEBREW_PREFIX}/lib)

  include_directories(${HOMEBREW_PREFIX}/opt/gettext/include)
  link_libraries(

=== systemtests/CMakeLists.txt ===
#   BAREOS® - Backup Archiving REcovery Open Sourced
#
#   Copyright (C) 2019-2024 Bareos GmbH & Co. KG
#
#   This program is Free Software; you can redistribute it and/or
#   modify it under the terms of version three of the GNU Affero General Public
#   License as published by the Free Software Foundation and included
#   in the file LICENSE.
#
#   This program is distributed in the hope that it will be useful, but
#   WITHOUT ANY WARRANTY; without even the implied warranty of
#   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
#   Affero General Public License for more details.
#
#   You should have received a copy of the GNU Affero General Public License
#   along with this program; if not, write to the Free Software
#   Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA
#   02110-1301, USA.

message("Entering ${CMAKE_CURRENT_SOURCE_DIR}")

project(bareos-systemtests)

list(APPEND CMAKE_MODULE_PATH "${CMAKE_CURRENT_SOURCE_DIR}/cmake")
include(BareosSystemtestFunctions)

# ps is required for systemtests
find_program(PS ps REQUIRED)

set(USER $ENV{USER})

# set the data encryption and signature keys
set(pki_keypair ${CMAKE_CURRENT_SOURCE_DIR}/pki/fd.pem)
set(pki_master_key ${CMAKE_CURRENT_SOURCE_DIR}/pki/master.cert)

# set the tls ca keys
set(tls_ca_certificate ${CMAKE_CURRENT_SOURCE_DIR}/tls/bareos-ca.pem)

set(tls_fd_certificate
    ${CMAKE_CURRENT_SOURCE_DIR}/tls/client1.bareos.org-cert.pem
)
set(tls_fd_key ${CMAKE_CURRENT_SOURCE_DIR}/tls/client1.bareos.org-key.pem)

set(tls_sd_certificate
    ${CMAKE_CURRENT_SOURCE_DIR}/tls/bareos-sd1.bareos.org-cert.pem
)
set(tls_sd_key ${CMAKE_CURRENT_SOURCE_DIR}/tls/bareos-sd1.bareos.org-key.pem)

set(tls_dir_certificate
    ${CMAKE_CURRENT_SOURCE_DIR}/tls/bareos-dir.bareos.org-cert.pem
)
set(tls_dir_key ${CMAKE_CURRENT_SOURCE_DIR}/tls/bareos-dir.bareos.org-key.pem)

set(tls_con_certificate
    ${CMAKE_CURRENT_SOURCE_DIR}/tls/console.bareos.org-cert.pem
)
set(tls_con_key ${CMAKE_CURRENT_SOURCE_DIR}/tls/console.bareos.org-key.pem)

option(SYSTEMTESTS_S3_USE_HTTPS "Use tls for S3 connections in systemtests"
       "yes"
)
message("   SYSTEMTESTS_S3_USE_HTTPS: ${SYSTEMTESTS_S3_USE_HTTPS}")

if(SYSTEMTESTS_S3_USE_HTTPS)
  set(systemtests_s3_use_https "false")
else()
  set(systemtests_s3_use_https "true")
endif()

# Main starts here...

find_program(PG_CTL pg_ctl /usr/lib/postgresql/*/bin /usr/bin /bin)
get_filename_component(POSTGRES_BIN_PATH ${PG_CTL} DIRECTORY)
# message(STATUS "PG_CTL is ${PG_CTL}")
message(STATUS "POSTGRES_BIN_PATH is ${POSTGRES_BIN_PATH}")

find_program(PERL perl)

option(RUN_SYSTEMTESTS_ON_INSTALLED_FILES
       "configure the system tests to run on installed files (from packages)"
)

set(ALL_BINARIES_BEING_USED_BY_SYSTEMTESTS
    bareos-dir
    bareos-dbcheck
    bareos-fd
    bareos-test-fd
    bareos-sd
    bcopy
    btape
    bextract
    bareos-sd
    bls
    bscan
    bconsole
    bsmtp
    bwild
    bpluginfo
    bsmtp
    bscrypto
    btestls
    drivetype
    fstype
    bregex
    testfind
)

if(TARGET bareos_vadp_dumper)
  list(APPEND ALL_BINARIES_BEING_USED_BY_SYSTEMTESTS bareos_vadp_dumper)
endif()

cmake_print_variables(RUN_SYSTEMTESTS_ON_INSTALLED_FILES)

message(STATUS "Looking for binaries and paths...")
find_systemtests_binary_paths(${ALL_BINARIES_BEING_USED_BY_SYSTEMTESTS})

# extract  db version from cats.h
file(STRINGS ${CMAKE_SOURCE_DIR}/core/src/cats/cats.h DB_VERSION_STRING
     REGEX .*BDB_VERSION.*
)
string(REGEX MATCH [0-9]+ BDB_VERSION ${DB_VERSION_STRING})
message(STATUS "db version from cats.h is ${BDB_VERSION}")

cmake_print_variables(DEFAULT_DB_TYPE)

# set(TAPEDRIVE "TAPEDRIVE")

set(archivedir "${PROJECT_BINARY_DIR}/archivedir")

set(bin ${PROJECT_BINARY_DIR}/bin)
set(bindir ${PROJECT_BINARY_DIR}/bin)

set(BAREOS_CONFIG_DIR ${conf})
set(db_name "regress")
set(db_port "5432")
set(db_user "${systemtest_db_user}")
set(db_password "${systemtest_db_password}")

set(logdir "log")
set(python_plugin_module_src_test_dir_relative "python-modules")
set(dumps ${PROJECT_BINARY_DIR}/dumps)
set(plugindirtmp ${PROJECT_BINARY_DIR}/plugindirtmp)
set(rscripts ${PROJECT_BINARY_DIR}/scripts)
set(sbindir ${PROJECT_BINARY_DIR}/sbin)
set(scriptdir ${PROJECT_BINARY_DIR}/scripts)
set(scripts ${PROJECT_BINARY_DIR}/scripts)
set(smtp_host "smtp_host")
set(src ${PROJECT_BINARY_DIR}/src)
set(subsysdir ${PROJECT_BINARY_DIR}/subsysdir)
set(tmp ${PROJECT_BINARY_DIR}/tmp)
set(tmpdir ${tmp})
set(tmpsrc ${PROJECT_BINARY_DIR}/tmpsrc)
set(working ${PROJECT_BINARY_DIR}/working)
set(working_dir ${PROJECT_BINARY_DIR}/working)

# for config-lib.sh: do not remove @DB___@ but replace them with the original
set(DB_NAME @DB_NAME@)
set(DB_USER @DB_USER@)
set(DB_PASS @DB_PASS@)
set(DB_VERSION @DB_VERSION@)

create_systemtests_directory()

set(tests_dir ${PROJECT_BINARY_DIR}/tests)

set(SYSTEMTEST_TIMEOUT
    "300"
    CACHE STRING "Timeout for systemtests (in seconds)"
)

set(BASEPORT 30001)

set(SYSTEMTEST_PREFIX "system:")

if(AUTOCHANGER_DEVICES_FOUND)
  if(MT AND MTX)
    set(AUTOCHANGER_TEST_ENABLED TRUE)
  else()
    message(FATAL_ERROR "mtx/mt not found for autochanger test")
  endif()
endif()

check_for_pamtest()

if(RUN_SYSTEMTESTS_ON_INSTALLED_FILES)
  set(TEST_INFO_TEXT "running system tests on installed files")
else()
  set(TEST_INFO_TEXT "running system tests on the sourcetree")
endif()

if(MINIO)
  execute_process(
    COMMAND "${CMAKE_BINARY_DIR}/systemtests/scripts/generate_minio_certs.sh"
    WORKING_DIRECTORY "${CMAKE_BINARY_DIR}/systemtests/tls/minio/"
    RESULT_VARIABLE RESULT_GENERATE_MINIO_CERTS
    OUTPUT_QUIET ERROR_QUIET
  )
  if(NOT "${RESULT_GENERATE_MINIO_CERTS}" STREQUAL "0")
    message(
      FATAL_ERROR
        "Creation of certificates failed: ${RESULT_GENERATE_MINIO_CERTS} ${CMAKE_BINARY_DIR}"
    )
  endif()
endif()

configure_file(
  "CTestCustom.cmake.in" "${CMAKE_BINARY_DIR}/CTestCustom.cmake" @ONLY
)
configure_file(
  "ctest_custom_pretest.sh.in"
  "${CMAKE_CURRENT_BINARY_DIR}/ctest_custom_pretest.sh" @ONLY
)

#
# webui: start
#

message(STATUS "Looking for webui test requirements ...")

set(AVAILABLE_WEBUI_SELENIUM_TESTS
    "admin-client_link_on_dashboard"
    "admin-client_disabling"
    "admin-rerun_job"
    "admin-restore"
    "admin-run_configured_job"
    "admin-run_default_job"
    "readonly-client_disabling"
    "readonly-rerun_job"
    "readonly-restore"
    "readonly-run_configured_job"
    "readonly-run_default_job"
)

set(WEBUI_TESTS_BROKEN
    admin-client_disabling # sometimes fails with a find_element exception
    readonly-client_disabling # sometimes fails with a find_element exception
)

find_program(PHP php)
find_program(CHROMEDRIVER chromedriver)
check_pymodule_available(3 selenium) # sets PYMODULE_3_SELENIUM_FOUND to TRUE or
# FALSE

message("   PHP:                       " ${PHP})
message("   PYTHON_EXECUTABLE:         " ${PYTHON_EXECUTABLE})
message("   PYMODULE_3_SELENIUM_FOUND: " ${PYMODULE_3_SELENIUM_FOUND})
message("   CHROMEDRIVER:              " ${CHROMEDRIVER})

if(PHP
   AND PYTHON_EXECUTABLE
   AND PYMODULE_3_SELENIUM_FOUND
   AND CHROMEDRIVER
)
  set(ENABLE_WEBUI_SELENIUM_TEST TRUE)
  message(STATUS "OK: all requirements for webui tests were met.")
else()
  set(ENABLE_WEBUI_SELENIUM_TEST FALSE)
  message(
    STATUS "NOT OK: disabling webui tests as not all requirements were found."
  )
endif()

set(WEBUI_TEST_PREFIX "webui:")
if(NOT ENABLE_WEBUI_SELENIUM_TEST)
  set(WEBUI_SELENIUM_TESTS)
  foreach(TEST_NAME_DISABLED ${AVAILABLE_WEBUI_SELENIUM_TESTS})
    add_test(NAME ${WEBUI_TEST_PREFIX}${TEST_NAME_DISABLED} COMMAND false)
    set_tests_properties(
      ${WEBUI_TEST_PREFIX}${TEST_NAME_DISABLED} PROPERTIES DISABLED true
    )
    message(STATUS "Disabled test: ${WEBUI_TEST_PREFIX}${TEST_NAME_DISABLED}")
  endforeach()
else()
  # webui specific settings
  set(WEBUI_SELENIUM_TESTS ${AVAILABLE_WEBUI_SELENIUM_TESTS})
  foreach(TEST_NAME ${WEBUI_SELENIUM_TESTS})
    message(STATUS "Configuring test: ${WEBUI_TEST_PREFIX}${TEST_NAME}")

    prepare_test(${TEST_NAME})
    prepare_testdir_for_daemon_run()
    # split WEBUI_TEST_NAME into PROFILE and TESTNAME
    string(REPLACE "-" ";" SELENIUM_TESTCOMPONENTS ${TEST_NAME})
    # "webui-admin-restore"
    list(GET SELENIUM_TESTCOMPONENTS 0 BAREOS_WEBUI_PROFILE)
    list(GET SELENIUM_TESTCOMPONENTS 1 BAREOS_WEBUI_TESTNAME)

    set(WEBUICONFDIR ${current_test_directory}/etc/bareos-webui) # used for test
                                                                 # environment
                                                                 # settings
    file(MAKE_DIRECTORY ${WEBUICONFDIR})
    configure_file(
      "${CMAKE_SOURCE_DIR}/webui/config/autoload/global.php.in"
      "${current_test_directory}/webui/config/autoload/global.php" @ONLY
    )
    configurefilestosystemtest(
      "systemtests" "tests/${TEST_NAME}" "*" @ONLY "tests/webui-common"
    )

    configure_file("environment.in" "tests/${TEST_NAME}/environment" @ONLY)
    # create a bin/bareos and bin/bconsole script in every testdir for
    # start/stop and bconsole file(MAKE_DIRECTORY
    # "${CMAKE_BINARY_DIR}/tests/${TEST_NAME}/bin")
    configure_file("bin/bconsole" "tests/${TEST_NAME}/bin/bconsole" COPYONLY)
    configure_file("bin/bareos" "tests/${TEST_NAME}/bin/bareos" COPYONLY)

    add_test(
      NAME "${WEBUI_TEST_PREFIX}${TEST_NAME}"
      COMMAND ${tests_dir}/${TEST_NAME}/testrunner
      WORKING_DIRECTORY ${tests_dir}/${TEST_NAME}
    )
    if(${TEST_NAME} IN_LIST WEBUI_TESTS_BROKEN)
      set_tests_properties(
        ${WEBUI_TEST_PREFIX}${TEST_NAME} PROPERTIES LABELS "broken"
      )
    endif()
    set_tests_properties(
      ${WEBUI_TEST_PREFIX}${TEST_NAME} PROPERTIES TIMEOUT 120 COST 1.0
    )
    math(EXPR BASEPORT "${BASEPORT} + 10")
  endforeach()
  # unset variables, so that they are not set in other environments.
  set(BAREOS_WEBUI_PROFILE "")
  set(BAREOS_WEBUI_TESTNAME "")
endif()

#
# webui: end
#

add_subdirectory(tests)

=== contrib/fd-plugins/CMakeLists.txt ===
#   BAREOS® - Backup Archiving REcovery Open Sourced
#
#   Copyright (C) 2021-2021 Bareos GmbH & Co. KG
#
#   This program is Free Software; you can redistribute it and/or
#   modify it under the terms of version three of the GNU Affero General Public
#   License as published by the Free Software Foundation and included
#   in the file LICENSE.
#
#   This program is distributed in the hope that it will be useful, but
#   WITHOUT ANY WARRANTY; without even the implied warranty of
#   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
#   Affero General Public License for more details.
#
#   You should have received a copy of the GNU Affero General Public License
#   along with this program; if not, write to the Free Software
#   Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA
#   02110-1301, USA.

# bareos_elasticsearch is only a PoC
#install(DIRECTORY bareos_elasticsearch DESTINATION ${PYTHON_MODULE_PATH} COMPONENT filedaemon)
install(DIRECTORY bareos_mysql_dump DESTINATION ${PYTHON_MODULE_PATH} COMPONENT filedaemon)
# bareos_option_example is only an example
#install(DIRECTORY bareos_option_example DESTINATION ${PYTHON_MODULE_PATH} COMPONENT filedaemon)
install(DIRECTORY bareos_tasks DESTINATION ${PYTHON_MODULE_PATH} COMPONENT filedaemon)
install(DIRECTORY openvz7 DESTINATION ${PYTHON_MODULE_PATH} COMPONENT filedaemon)

=== contrib/misc/CMakeLists.txt ===
#   BAREOS® - Backup Archiving REcovery Open Sourced
#
#   Copyright (C) 2021-2021 Bareos GmbH & Co. KG
#
#   This program is Free Software; you can redistribute it and/or
#   modify it under the terms of version three of the GNU Affero General Public
#   License as published by the Free Software Foundation and included
#   in the file LICENSE.
#
#   This program is distributed in the hope that it will be useful, but
#   WITHOUT ANY WARRANTY; without even the implied warranty of
#   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
#   Affero General Public License for more details.
#
#   You should have received a copy of the GNU Affero General Public License
#   along with this program; if not, write to the Free Software
#   Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA
#   02110-1301, USA.

add_subdirectory(bsmc)
add_subdirectory(triggerjob)

=== core/scripts/CMakeLists.txt ===
#   BAREOS® - Backup Archiving REcovery Open Sourced
#
#   Copyright (C) 2017-2023 Bareos GmbH & Co. KG
#
#   This program is Free Software; you can redistribute it and/or
#   modify it under the terms of version three of the GNU Affero General Public
#   License as published by the Free Software Foundation and included
#   in the file LICENSE.
#
#   This program is distributed in the hope that it will be useful, but
#   WITHOUT ANY WARRANTY; without even the implied warranty of
#   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
#   Affero General Public License for more details.
#
#   You should have received a copy of the GNU Affero General Public License
#   along with this program; if not, write to the Free Software
#   Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA
#   02110-1301, USA.
message("Entering ${CMAKE_CURRENT_SOURCE_DIR}")

install(
  FILES bareos btraceback
  PERMISSIONS OWNER_READ OWNER_WRITE OWNER_EXECUTE GROUP_READ GROUP_EXECUTE
              WORLD_READ WORLD_EXECUTE
  DESTINATION "${sbindir}"
)

install(
  FILES bareos-ctl-fd
  PERMISSIONS OWNER_READ OWNER_WRITE OWNER_EXECUTE GROUP_READ GROUP_EXECUTE
              WORLD_READ WORLD_EXECUTE
  DESTINATION "${scriptdir}"
  COMPONENT filedaemon
)

install(
  FILES bareos bareos-config
  PERMISSIONS OWNER_READ OWNER_WRITE OWNER_EXECUTE GROUP_READ GROUP_EXECUTE
              WORLD_READ WORLD_EXECUTE
  DESTINATION "${scriptdir}"
)

install(
  FILES bareos-config-lib.sh bareos-ctl-funcs btraceback.gdb btraceback.dbx
        btraceback.mdb
  PERMISSIONS OWNER_READ OWNER_WRITE GROUP_READ WORLD_READ
  DESTINATION "${scriptdir}"
)
if(TARGET python3-fd)
  install(
    FILES bareos_encode_string.py
    PERMISSIONS OWNER_READ OWNER_WRITE OWNER_EXECUTE GROUP_READ GROUP_EXECUTE
                WORLD_READ WORLD_EXECUTE
    DESTINATION "${scriptdir}"
  )
endif()

if(NOT client-only)
  install(
    FILES mtx-changer disk-changer bareos-explorer bareos-glusterfind-wrapper
          bareos-ctl-dir bareos-ctl-sd
    PERMISSIONS OWNER_READ OWNER_WRITE OWNER_EXECUTE GROUP_READ GROUP_EXECUTE
                WORLD_READ WORLD_EXECUTE
    DESTINATION "${scriptdir}"
  )

  install(FILES mtx-changer.conf DESTINATION "${confdir}")

  install(
    FILES logrotate
    DESTINATION "${sysconfdir}/logrotate.d"
    RENAME bareos-dir
  )
endif()

=== core/src/CMakeLists.txt ===
#   BAREOS® - Backup Archiving REcovery Open Sourced
#
#   Copyright (C) 2017-2021 Bareos GmbH & Co. KG
#
#   This program is Free Software; you can redistribute it and/or
#   modify it under the terms of version three of the GNU Affero General Public
#   License as published by the Free Software Foundation and included
#   in the file LICENSE.
#
#   This program is distributed in the hope that it will be useful, but
#   WITHOUT ANY WARRANTY; without even the implied warranty of
#   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
#   Affero General Public License for more details.
#
#   You should have received a copy of the GNU Affero General Public License
#   along with this program; if not, write to the Free Software
#   Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA
#   02110-1301, USA.
message("Entering ${CMAKE_CURRENT_SOURCE_DIR}")

add_subdirectory(filed)

if(NOT client-only)
  add_subdirectory(tools)
  add_subdirectory(cats)
  if(NOT HAVE_WIN32 AND ndmp)
    add_subdirectory(ndmp)
  endif()
  if(VIXDISKLIB_FOUND)
    add_subdirectory(vmware)
  endif()
  add_subdirectory(stored)
  add_subdirectory(dird)
endif()

if(RUN_SYSTEMTESTS_ON_INSTALLED_FILES)
  message(
    STATUS "Skipping unit tests as testing on installed files is requested"
  )
elseif(NOT GTest_FOUND)
  message(STATUS "Skipping unit tests as gtest was not found")
else()
  add_subdirectory(tests)
endif()

if(BUILD_BENCHMARKS)
  add_subdirectory(benchmarks)
endif()

if(ENABLE_BCONSOLE)
  add_subdirectory(console)
endif()

if(${HAVE_LMDB})
  add_subdirectory(lmdb)
endif()
add_subdirectory(lib)
add_subdirectory(findlib)
add_subdirectory(plugins)
add_subdirectory(fastlz)
if(${traymonitor})
  add_subdirectory(qt-tray-monitor)
endif()

=== docs/manuals/CMakeLists.txt ===
# BAREOS® - Backup Archiving REcovery Open Sourced
#
# Copyright (C) 2019-2022 Bareos GmbH & Co. KG
#
# This program is Free Software; you can redistribute it and/or
# modify it under the terms of version three of the GNU Affero General Public
# License as published by the Free Software Foundation and included
# in the file LICENSE.
#
# This program is distributed in the hope that it will be useful, but
# WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
# Affero General Public License for more details.
#
# You should have received a copy of the GNU Affero General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA
# 02110-1301, USA.

project(bareos-docs NONE)

set_directory_properties(PROPERTIES CLEAN_NO_CUSTOM 1)

if(${docs-build-json})

  # commands building json files ######
  add_custom_command(
    OUTPUT
      ${PROJECT_SOURCE_DIR}/source/include/autogenerated/bareos-dir-config-schema.json
    COMMAND bareos-dir --xs >/dev/null
    COMMAND
      bareos-dir --xs
      >${PROJECT_SOURCE_DIR}/source/include/autogenerated/bareos-dir-config-schema.json
    COMMAND
      sed --in-place --expression="/\\\"version\\\":/d"
      ${PROJECT_SOURCE_DIR}/source/include/autogenerated/bareos-dir-config-schema.json
    DEPENDS bareos-dir
  )

  add_custom_command(
    OUTPUT
      ${PROJECT_SOURCE_DIR}/source/include/autogenerated/bareos-sd-config-schema.json
    COMMAND bareos-sd --xs >/dev/null
    COMMAND
      bareos-sd --xs
      >${PROJECT_SOURCE_DIR}/source/include/autogenerated/bareos-sd-config-schema.json
    COMMAND
      sed --in-place --expression="/\\\"version\\\":/d"
      ${PROJECT_SOURCE_DIR}/source/include/autogenerated/bareos-sd-config-schema.json
    DEPENDS bareos-sd
  )

  add_custom_command(
    OUTPUT
      ${PROJECT_SOURCE_DIR}/source/include/autogenerated/bareos-fd-config-schema.json
    COMMAND bareos-fd --xs >/dev/null
    COMMAND
      bareos-fd --xs
      >${PROJECT_SOURCE_DIR}/source/include/autogenerated/bareos-fd-config-schema.json
    COMMAND
      sed --in-place --expression="/\\\"version\\\":/d"
      ${PROJECT_SOURCE_DIR}/source/include/autogenerated/bareos-fd-config-schema.json
    DEPENDS bareos-fd
  )

  add_custom_command(
    OUTPUT
      ${PROJECT_SOURCE_DIR}/source/include/autogenerated/bconsole-config-schema.json
    COMMAND bconsole --xs >/dev/null
    COMMAND
      bconsole --xs
      >${PROJECT_SOURCE_DIR}/source/include/autogenerated/bconsole-config-schema.json
    COMMAND
      sed --in-place --expression="/\\\"version\\\":/d"
      ${PROJECT_SOURCE_DIR}/source/include/autogenerated/bconsole-config-schema.json
    DEPENDS bconsole
  )

  add_custom_command(
    OUTPUT
      ${PROJECT_SOURCE_DIR}/source/include/autogenerated/bareos-tray-monitor-config-schema.json
    COMMAND bareos-tray-monitor --xs >/dev/null
    COMMAND
      bareos-tray-monitor --xs
      >${PROJECT_SOURCE_DIR}/source/include/autogenerated/bareos-tray-monitor-config-schema.json
    COMMAND
      sed --in-place --expression="/\\\"version\\\":/d"
      ${PROJECT_SOURCE_DIR}/source/include/autogenerated/bareos-tray-monitor-config-schema.json
    DEPENDS bareos-tray-monitor
  )

  set(AUTOGENERATED_RESOURCE_DESCRIPTION_JSON_FILES
      ${PROJECT_SOURCE_DIR}/source/include/autogenerated/bareos-dir-config-schema.json
      ${PROJECT_SOURCE_DIR}/source/include/autogenerated/bareos-sd-config-schema.json
      ${PROJECT_SOURCE_DIR}/source/include/autogenerated/bareos-fd-config-schema.json
      ${PROJECT_SOURCE_DIR}/source/include/autogenerated/bconsole-config-schema.json
      ${PROJECT_SOURCE_DIR}/source/include/autogenerated/bareos-tray-monitor-config-schema.json
  )

  #
  # commands building usage files ######
  #

  set(AUTOGENERATE_DIR ${PROJECT_SOURCE_DIR}/source/include/autogenerated/)
  set(USAGE_DIR ${AUTOGENERATE_DIR}/usage/)

  add_custom_command(
    OUTPUT ${USAGE_DIR}/bareos-dir.txt
    COMMAND bareos-dir --help >/dev/null
    COMMAND ${PROJECT_SOURCE_DIR}/scripts/get-usage.sh $<TARGET_FILE:bareos-dir>
            ${USAGE_DIR}
    DEPENDS bareos-dir
  )

  add_custom_command(
    OUTPUT ${USAGE_DIR}/bareos-sd.txt
    COMMAND bareos-sd --help >/dev/null
    COMMAND ${PROJECT_SOURCE_DIR}/scripts/get-usage.sh $<TARGET_FILE:bareos-sd>
            ${USAGE_DIR}
    DEPENDS bareos-sd
  )

  add_custom_command(
    OUTPUT ${USAGE_DIR}/bareos-fd.txt
    COMMAND bareos-fd --help >/dev/null
    COMMAND ${PROJECT_SOURCE_DIR}/scripts/get-usage.sh $<TARGET_FILE:bareos-fd>
            ${USAGE_DIR}
    DEPENDS bareos-fd
  )

  add_custom_command(
    OUTPUT ${USAGE_DIR}/bconsole.txt
    COMMAND bconsole --help >/dev/null
    COMMAND ${PROJECT_SOURCE_DIR}/scripts/get-usage.sh $<TARGET_FILE:bconsole>
            ${USAGE_DIR}
    DEPENDS bconsole
  )

  # add_custom_command( OUTPUT ${USAGE_DIR}/bareos-tray-monitor.txt COMMAND
  # bareos-tray-monitor --help >/dev/null COMMAND
  # ${PROJECT_SOURCE_DIR}/scripts/get-usage.sh
  # $<TARGET_FILE:bareos-tray-monitor> #{USAGE_DIR} DEPENDS
  # $<$<BOOL:${docs-build-json}>:bareos-tray-monitor> )

  add_custom_command(
    OUTPUT ${USAGE_DIR}/bareos-dbcheck.txt
    COMMAND bareos-dbcheck --help >/dev/null
    COMMAND ${PROJECT_SOURCE_DIR}/scripts/get-usage.sh
            $<TARGET_FILE:bareos-dbcheck> ${USAGE_DIR}
    DEPENDS bareos-dbcheck
  )

  add_custom_command(
    OUTPUT ${USAGE_DIR}/bcopy.txt
    COMMAND bcopy --help >/dev/null
    COMMAND ${PROJECT_SOURCE_DIR}/scripts/get-usage.sh $<TARGET_FILE:bcopy>
            ${USAGE_DIR}
    DEPENDS bcopy
  )

  add_custom_command(
    OUTPUT ${USAGE_DIR}/bextract.txt
    COMMAND bextract --help >/dev/null
    COMMAND ${PROJECT_SOURCE_DIR}/scripts/get-usage.sh $<TARGET_FILE:bextract>
            ${USAGE_DIR}
    DEPENDS bextract
  )

  add_custom_command(
    OUTPUT ${USAGE_DIR}/bls.txt
    COMMAND bls --help >/dev/null
    COMMAND ${PROJECT_SOURCE_DIR}/scripts/get-usage.sh $<TARGET_FILE:bls>
            ${USAGE_DIR}
    DEPENDS bls
  )

  add_custom_command(
    OUTPUT ${USAGE_DIR}/bpluginfo.txt
    COMMAND bpluginfo --help >/dev/null
    COMMAND ${PROJECT_SOURCE_DIR}/scripts/get-usage.sh $<TARGET_FILE:bpluginfo>
            ${USAGE_DIR}
    DEPENDS bpluginfo
  )

  add_custom_command(
    OUTPUT ${USAGE_DIR}/bregex.txt
    COMMAND bregex --help >/dev/null
    COMMAND ${PROJECT_SOURCE_DIR}/scripts/get-usage.sh $<TARGET_FILE:bregex>
            ${USAGE_DIR}
    DEPENDS bregex
  )

  add_custom_command(
    OUTPUT ${USAGE_DIR}/bscan.txt
    COMMAND bscan --help >/dev/null
    COMMAND ${PROJECT_SOURCE_DIR}/scripts/get-usage.sh $<TARGET_FILE:bscan>
            ${USAGE_DIR}
    DEPENDS bscan
  )

  add_custom_command(
    OUTPUT ${USAGE_DIR}/bsmtp.txt
    COMMAND bsmtp --help > /dev/null
    COMMAND ${PROJECT_SOURCE_DIR}/scripts/get-usage.sh $<TARGET_FILE:bsmtp>
            ${USAGE_DIR}
    DEPENDS bsmtp
  )

  add_custom_command(
    OUTPUT ${USAGE_DIR}/btape.txt
    COMMAND btape --help >/dev/null
    COMMAND ${PROJECT_SOURCE_DIR}/scripts/get-usage.sh $<TARGET_FILE:btape>
            ${USAGE_DIR}
    DEPENDS btape
  )

  add_custom_command(
    OUTPUT ${USAGE_DIR}/bwild.txt
    COMMAND bwild --help >/dev/null
    COMMAND ${PROJECT_SOURCE_DIR}/scripts/get-usage.sh $<TARGET_FILE:bwild>
            ${USAGE_DIR}
    DEPENDS bwild
  )

  set(AUTOGENERATED_USAGE_FILES
      ${USAGE_DIR}/bareos-dir.txt
      ${USAGE_DIR}/bareos-sd.txt
      ${USAGE_DIR}/bareos-fd.txt
      ${USAGE_DIR}/bconsole.txt
      ${USAGE_DIR}/bareos-dbcheck.txt
      ${USAGE_DIR}/bcopy.txt
      ${USAGE_DIR}/bextract.txt
      ${USAGE_DIR}/bls.txt
      ${USAGE_DIR}/bpluginfo.txt
      ${USAGE_DIR}/bregex.txt
      ${USAGE_DIR}/bscan.txt
      ${USAGE_DIR}/bsmtp.txt
      ${USAGE_DIR}/btape.txt
      ${USAGE_DIR}/bwild.txt
  )

  set(CLEAN_JSON_FILES
      rm -f ${PROJECT_SOURCE_DIR}/source/include/autogenerated/*.json
  )

endif() # if(${docs-build-json})

# target: clean-docs ######
add_custom_target(
  clean-docs
  COMMAND ${CLEAN_JSON_FILES}
  COMMAND rm -f ${PROJECT_SOURCE_DIR}/source/include/autogenerated/*.inc
  COMMAND rm -rf ${PROJECT_SOURCE_DIR}/source/include/autogenerated/autosummary/
  COMMAND rm -rf ${PROJECT_BINARY_DIR}/BareosMainReference
)

# target: check-git ###### To prevent documentation to be built out of sync with
# the actual binaries, this target checks if the generated json files differ
# from the ones in the repository.

add_custom_target(
  check-git
  COMMAND git diff -p --exit-code --stat=80
          ${PROJECT_SOURCE_DIR}/source/include/autogenerated
  DEPENDS ${AUTOGENERATED_RESOURCE_DESCRIPTION_JSON_FILES}
          ${AUTOGENERATED_USAGE_FILES}
  WORKING_DIRECTORY ${PROJECT_SOURCE_DIR}
  COMMENT
    "Comparing json files in \"${PROJECT_SOURCE_DIR}/source/include/autogenerated\" with git repo"
)

set(SPHINX_OPTS $ENV{SPHINX_OPTS})
set(SPHINX_COMMAND sphinx-build)
set(SPHINX_BUILDDIR ${PROJECT_BINARY_DIR}/BareosMainReference)
set(SPHINX_SOURCE_DIR ${PROJECT_SOURCE_DIR}/source)

if(${docs-only})
  set(DOCS_ALL ALL) # this enables "make docs" by just typing "make"
endif()

add_custom_target(
  docs-check-urls
  COMMAND ${SPHINX_COMMAND} -M linkcheck "${SPHINX_SOURCE_DIR}"
          "${SPHINX_BUILDDIR}"
  WORKING_DIRECTORY ${PROJECT_SOURCE_DIR}
  COMMENT "Check if the URLs used in the documentation are still valid targets."
)

# target: docs ######
add_custom_target(
  docs
  ${DOCS_ALL}
  COMMAND ${SPHINX_COMMAND} -M html "${SPHINX_SOURCE_DIR}" "${SPHINX_BUILDDIR}"
          "${SPHINX_OPTS}"
  COMMAND ${SPHINX_COMMAND} -b man "${SPHINX_SOURCE_DIR}" "${SPHINX_BUILDDIR}"
          "${SPHINX_OPTS}"
  DEPENDS $<$<BOOL:${docs-build-json}>:clean-docs>
  DEPENDS check-git
)

=== systemtests/tests/CMakeLists.txt ===
#   BAREOS® - Backup Archiving REcovery Open Sourced
#
#   Copyright (C) 2021-2025 Bareos GmbH & Co. KG
#
#   This program is Free Software; you can redistribute it and/or
#   modify it under the terms of version three of the GNU Affero General Public
#   License as published by the Free Software Foundation and included
#   in the file LICENSE.
#
#   This program is distributed in the hope that it will be useful, but
#   WITHOUT ANY WARRANTY; without even the implied warranty of
#   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
#   Affero General Public License for more details.
#
#   You should have received a copy of the GNU Affero General Public License
#   along with this program; if not, write to the Free Software
#   Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA
#   02110-1301, USA.

message("Adding systemtests from ${CMAKE_CURRENT_SOURCE_DIR}")
add_subdirectory(accurate-lmdb-stresstest)
add_subdirectory(accurate-stresstest)
add_subdirectory(acl)
add_subdirectory(admin-job)
add_subdirectory(always-incremental-consolidate)
add_subdirectory(autochanger)
add_subdirectory(autoxflate)
add_subdirectory(bareos-basic)
add_subdirectory(bareos-concurrency)
add_subdirectory(bareos-acl)
add_subdirectory(bconsole-basic)
add_subdirectory(bconsole-pam)
add_subdirectory(block-size)
add_subdirectory(bscan-bextract-bls-bcopy)
add_subdirectory(catalog)
add_subdirectory(checkpoints)
add_subdirectory(chflags)
add_subdirectory(client-initiated)
add_subdirectory(commandline-options)
add_subdirectory(config-dump)
add_subdirectory(copy-migrate)
add_subdirectory(copy-archive-job)
add_subdirectory(dbcheck)
add_subdirectory(dedupable)
add_subdirectory(deprecation)
add_subdirectory(droplet-s3)
add_subdirectory(encrypt-signature-no-tls)
add_subdirectory(encrypt-signature-tls-cert)
add_subdirectory(fileindex-overflow)
if(HAVE_DYNAMIC_SD_BACKENDS)
  add_subdirectory(file-autochanger)
endif()
add_subdirectory(file-count-regression)
add_subdirectory(fileset-multiple-blocks)
add_subdirectory(filesets)
add_subdirectory(gfapi-fd)
add_subdirectory(glusterfs-backend)
add_subdirectory(just-in-time-reservation)
add_subdirectory(list-backups)
add_subdirectory(messages)
add_subdirectory(mtx-changer)
add_subdirectory(multiplied-device)
add_subdirectory(multiple-clients)
add_subdirectory(ndmp-bareos)
add_subdirectory(notls)
add_subdirectory(parallel-jobs)
add_subdirectory(parser)
add_subdirectory(passive)
add_subdirectory(pruning)
add_subdirectory(py3plug-dir)
add_subdirectory(py3plug-fd-contrib-bareos_tasks_mysql)
add_subdirectory(py3plug-fd-ldap)
add_subdirectory(py3plug-fd-libcloud)
add_subdirectory(py3plug-fd-local-fileset-restoreobject)
add_subdirectory(py3plug-fd-mariabackup)
add_subdirectory(py3plug-fd-percona-xtrabackup)
add_subdirectory(py3plug-fd-vmware)
add_subdirectory(py3plug-sd)
add_subdirectory(py3plug-fd-local-fileset-basic)
add_subdirectory(py3plug-fd-basic)
add_subdirectory(py3plug-fd-contrib-mysql_dump)
add_subdirectory(py3plug-fd-postgres)
add_subdirectory(py3plug-fd-postgresql)
add_subdirectory(python-bareos)
add_subdirectory(python-pam)
add_subdirectory(quota-softquota)
add_subdirectory(reload)
add_subdirectory(restapi)
add_subdirectory(restore)
add_subdirectory(scheduler)
add_subdirectory(scsicrypto)
add_subdirectory(sparse-file)
add_subdirectory(spool)
add_subdirectory(stresstest)
add_subdirectory(strippath)
add_subdirectory(testfind)
add_subdirectory(tlsrestricted)
add_subdirectory(tls-suites)
add_subdirectory(truncate-command)
add_subdirectory(upgrade-database)
add_subdirectory(virtualfull-basic)
add_subdirectory(virtualfull-bscan)
add_subdirectory(virtualfull-deletedfiles)
add_subdirectory(xattr)

=== core/platforms/debian/CMakeLists.txt ===
#   BAREOS® - Backup Archiving REcovery Open Sourced
#
#   Copyright (C) 2017-2023 Bareos GmbH & Co. KG
#
#   This program is Free Software; you can redistribute it and/or
#   modify it under the terms of version three of the GNU Affero General Public
#   License as published by the Free Software Foundation and included
#   in the file LICENSE.
#
#   This program is distributed in the hope that it will be useful, but
#   WITHOUT ANY WARRANTY; without even the implied warranty of
#   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
#   Affero General Public License for more details.
#
#   You should have received a copy of the GNU Affero General Public License
#   along with this program; if not, write to the Free Software
#   Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA
#   02110-1301, USA.
message("Entering ${CMAKE_CURRENT_SOURCE_DIR}")

set(DESTSTARTDIR "${sysconfdir}/init.d/")

message(STATUS "installing startfiles to ${DESTSTARTDIR}")

# logrotate

# dbconfig
install(
  FILES "${CMAKE_CURRENT_LIST_DIR}/../debian/set_dbconfig_vars.sh"
  DESTINATION "${scriptdir}/"
  PERMISSIONS OWNER_READ OWNER_WRITE OWNER_EXECUTE GROUP_READ GROUP_EXECUTE
              WORLD_READ WORLD_EXECUTE
)

macro(bareos_install_sql_files_to_dbconfig_common)
  set(oneValueArgs BAREOS_DB_NAME DEBIAN_DB_NAME)
  cmake_parse_arguments(
    DB_CONFIG_COMMON "${options}" "${oneValueArgs}" "${multiValueArgs}" ${ARGN}
  )

  if(DB_CONFIG_COMMON_BAREOS_DB_NAME STREQUAL "postgresql")
    install(
      DIRECTORY
      DESTINATION
        "${CMAKE_INSTALL_FULL_DATAROOTDIR}/dbconfig-common/data/bareos-database-common/install/"
    )

    install(
      FILES
        "${CMAKE_SOURCE_DIR}/core/src/cats/ddl/creates/${DB_CONFIG_COMMON_BAREOS_DB_NAME}.sql"
      DESTINATION
        "${CMAKE_INSTALL_FULL_DATAROOTDIR}/dbconfig-common/data/bareos-database-common/install/"
      RENAME "${DB_CONFIG_COMMON_DEBIAN_DB_NAME}"
    )
  endif()

  install(
    DIRECTORY
    DESTINATION
      "${CMAKE_INSTALL_FULL_DATAROOTDIR}/dbconfig-common/data/bareos-database-common/upgrade/${DB_CONFIG_COMMON_DEBIAN_DB_NAME}/"
  )
  file(
    GLOB
    SQLFILES
    "${CMAKE_SOURCE_DIR}/core/src/cats/ddl/updates/${DB_CONFIG_COMMON_BAREOS_DB_NAME}.*_*.sql"
  )
  foreach(SQLFILE ${SQLFILES})
    get_filename_component(BASENAME ${SQLFILE} NAME)
    string(REGEX MATCH "([0-9]+)_([0-9]+)\\.sql" DUMMMY ${SQLFILE})
    set(FROM_VERSION ${CMAKE_MATCH_1})
    set(TO_VERSION ${CMAKE_MATCH_2})
    # file(CREATE_LINK ${NAME} ${UPGRADE_DIR}/${TO_VERSION} SYMBOLIC)
    message(
      "WILL INSTALL  ${SQLFILE} to ${CMAKE_INSTALL_FULL_DATAROOTDIR}/dbconfig-common/data/bareos-database-common/upgrade/${DB_CONFIG_COMMON_DEBIAN_DB_NAME}/${TO_VERSION}"
    )
    install(
      FILES ${SQLFILE}
      DESTINATION
        ${CMAKE_INSTALL_FULL_DATAROOTDIR}/dbconfig-common/data/bareos-database-common/upgrade/${DB_CONFIG_COMMON_DEBIAN_DB_NAME}/
      RENAME ${TO_VERSION}
    )
  endforeach()

  install(
    DIRECTORY
    DESTINATION
      "${CMAKE_INSTALL_FULL_DATAROOTDIR}/dbconfig-common/data/bareos-database-common/upgrade"
  )

  install(
    DIRECTORY
    DESTINATION
      "${CMAKE_INSTALL_FULL_DATAROOTDIR}/dbconfig-common/scripts/bareos-database-common/upgrade/${DB_CONFIG_COMMON_DEBIAN_DB_NAME}"
  )
  install(
    FILES
      "${CMAKE_CURRENT_LIST_DIR}/dbconfig-common/scripts/bareos-database-common/upgrade/pgsql/2170"
    DESTINATION
      "${CMAKE_INSTALL_FULL_DATAROOTDIR}/dbconfig-common/scripts/bareos-database-common/upgrade/${DB_CONFIG_COMMON_DEBIAN_DB_NAME}"
    RENAME 2170
    PERMISSIONS OWNER_READ OWNER_WRITE OWNER_EXECUTE GROUP_READ GROUP_EXECUTE
                WORLD_READ
  )
  install(
    FILES
      "${CMAKE_CURRENT_LIST_DIR}/dbconfig-common/scripts/bareos-database-common/upgrade/pgsql/2170"
    DESTINATION
      "${CMAKE_INSTALL_FULL_DATAROOTDIR}/dbconfig-common/scripts/bareos-database-common/upgrade/${DB_CONFIG_COMMON_DEBIAN_DB_NAME}"
    RENAME 2003
    PERMISSIONS OWNER_READ OWNER_WRITE OWNER_EXECUTE GROUP_READ GROUP_EXECUTE
                WORLD_READ
  )
  install(
    FILES
      "${CMAKE_CURRENT_LIST_DIR}/dbconfig-common/scripts/bareos-database-common/upgrade/pgsql/2170"
    DESTINATION
      "${CMAKE_INSTALL_FULL_DATAROOTDIR}/dbconfig-common/scripts/bareos-database-common/upgrade/${DB_CONFIG_COMMON_DEBIAN_DB_NAME}"
    RENAME 2004
    PERMISSIONS OWNER_READ OWNER_WRITE OWNER_EXECUTE GROUP_READ GROUP_EXECUTE
                WORLD_READ
  )

  install(
    DIRECTORY
    DESTINATION
      "${CMAKE_INSTALL_FULL_DATAROOTDIR}/dbconfig-common/data/bareos-database-common/upgrade-dbadmin/${DB_CONFIG_COMMON_DEBIAN_DB_NAME}"
  )
  if(EXISTS
     "${CMAKE_CURRENT_LIST_DIR}/share/dbconfig-common/data/bareos-database-common/upgrade-dbadmin/${DB_CONFIG_COMMON_DEBIAN_DB_NAME}/2170"
  )
    install(
      FILES
        "${CMAKE_CURRENT_LIST_DIR}/share/dbconfig-common/data/bareos-database-common/upgrade-dbadmin/${DB_CONFIG_COMMON_DEBIAN_DB_NAME}/2170"
      DESTINATION
        "${CMAKE_INSTALL_FULL_DATAROOTDIR}/dbconfig-common/data/bareos-database-common/upgrade-dbadmin/${DB_CONFIG_COMMON_DEBIAN_DB_NAME}"
      PERMISSIONS OWNER_READ OWNER_WRITE OWNER_EXECUTE GROUP_READ GROUP_EXECUTE
                  WORLD_READ
    )
    install(
      FILES
        "${CMAKE_CURRENT_LIST_DIR}/share/dbconfig-common/data/bareos-database-common/upgrade-dbadmin/${DB_CONFIG_COMMON_DEBIAN_DB_NAME}/2170"
      DESTINATION
        "${CMAKE_INSTALL_FULL_DATAROOTDIR}/dbconfig-common/data/bareos-database-common/upgrade-dbadmin/${DB_CONFIG_COMMON_DEBIAN_DB_NAME}"
      RENAME 2003
      PERMISSIONS OWNER_READ OWNER_WRITE OWNER_EXECUTE GROUP_READ GROUP_EXECUTE
                  WORLD_READ
    )
    install(
      FILES
        "${CMAKE_CURRENT_LIST_DIR}/share/dbconfig-common/data/bareos-database-common/upgrade-dbadmin/${DB_CONFIG_COMMON_DEBIAN_DB_NAME}/2170"
      DESTINATION
        "${CMAKE_INSTALL_FULL_DATAROOTDIR}/dbconfig-common/data/bareos-database-common/upgrade-dbadmin/${DB_CONFIG_COMMON_DEBIAN_DB_NAME}"
      RENAME 2004
      PERMISSIONS OWNER_READ OWNER_WRITE OWNER_EXECUTE GROUP_READ GROUP_EXECUTE
                  WORLD_READ
    )
  endif()

endmacro()

bareos_install_sql_files_to_dbconfig_common(
  BAREOS_DB_NAME postgresql DEBIAN_DB_NAME pgsql
)

=== core/platforms/systemd/CMakeLists.txt ===
#   BAREOS® - Backup Archiving REcovery Open Sourced
#
#   Copyright (C) 2017-2020 Bareos GmbH & Co. KG
#
#   This program is Free Software; you can redistribute it and/or
#   modify it under the terms of version three of the GNU Affero General Public
#   License as published by the Free Software Foundation and included
#   in the file LICENSE.
#
#   This program is distributed in the hope that it will be useful, but
#   WITHOUT ANY WARRANTY; without even the implied warranty of
#   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
#   Affero General Public License for more details.
#
#   You should have received a copy of the GNU Affero General Public License
#   along with this program; if not, write to the Free Software
#   Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA
#   02110-1301, USA.
message("Entering ${CMAKE_CURRENT_SOURCE_DIR}")

message(STATUS "CMAKE_CURRENT_LIST_FILE: " ${CMAKE_CURRENT_LIST_FILE})
message(STATUS "installing systemd files to  ${SYSTEMD_UNITDIR}")

install(FILES "bareos-sd.service" DESTINATION ${SYSTEMD_UNITDIR})
install(FILES "bareos-fd.service" DESTINATION ${SYSTEMD_UNITDIR})
install(FILES "bareos-dir.service" DESTINATION ${SYSTEMD_UNITDIR})

=== debian/changelog ===
bareos (23.1.6~pre1.e06a5555f-2) unstable; urgency=low

  * See https://docs.bareos.org/release-notes/

 -- Bareos Jenkins <noreply@bareos.com>  Wed, 21 Jan 2026 13:01:29 +0000

=== debian/control ===
# This file is autogenerated via cmake!
# If you need to regenerate it, run
#
#    make generate-debian-control
#
# debian/rules will do it automatically during the
# configuration phase

# we use conditional build-depends based on build profiles
# to get the right build-depends just fill DEB_BUILD_PROFILES
# with your distribution and codename (i.e. "debian buster"
# or "ubuntu xenial") and you'll get the full build-depends.
# Otherwise you will just get the common build-depends and
# might miss a feature or two.

Source: bareos
Section: admin
Priority: optional
Maintainer: Joerg Steffens <joerg.steffens@bareos.com>
Build-Depends: acl-dev,
 apache2 | httpd,
 bc,
 chrpath,
 cmake (>= 3.17.0) | cmake-mozilla,
 debhelper (>= 7.0.50~),
 dpkg-dev (>= 1.13.19),
 libacl1-dev,
 libcap-dev [linux-any],
 liblzo2-dev,
 qt6-base-dev | qtbase5-dev,
 libfmt-dev,
 libreadline-dev,
 libssl-dev,
 libx11-dev,
 libxml2-dev,
 libpq-dev,
 libjansson-dev,
 libjson-c-dev,
 logrotate,
 lsb-release,
 mtx [!hurd-any],
 ncurses-dev,
 openssl (>= 1.1.1),
 pkg-config,
 po-debconf (>= 0.8.2),
 python-dev <bullseye> <buster> <stretch> <xenial> <bionic>,
 zlib1g-dev,
 systemd,
 dh-systemd <buster> <stretch> <xenial> <bionic>,
 ucslint <univention>,
 univention-config-dev <univention>,
 wget <univention>
# required for bareos-storage-glusterfs and bareos-filedaemon-glusterfs-plugin
# glusterfs-common <bullseye> <buster> <stretch> <xenial> <bionic> <focal> <jammy>,
# libglusterfs-dev <bullseye> <buster> <focal> <jammy>,
Build-Conflicts: python2.2-dev, python2.3, python2.4, qt3-dev-tools, libqt4-dev
Standards-Version: 3.9.6
Vcs-Git: git://github.com/bareos/bareos.git -b master
Vcs-Browser: https://github.com/bareos/bareos/tree/master
Homepage: http://www.bareos.org/


Package:        bareos
Architecture:   any
Depends:        bareos-director (= ${binary:Version}), bareos-storage (= ${binary:Version}), bareos-client (= ${binary:Version}), ${misc:Depends}
Description: Backup Archiving Recovery Open Sourced - metapackage
 Bareos is a set of programs to manage backup, recovery and verification of
 data across a network of computers of different kinds.
 .
 It is efficient and relatively easy to use, while offering many advanced
 storage management features that make it easy to find and recover lost or
 damaged files. Due to its modular design, Bareos is scalable from small
 single computer systems to networks of hundreds of machines.
 .
 This metapackage installs the entire suite of Bareos applications: job
 scheduling, storage control, node connector, and administrative console.


Package:        bareos-bconsole
Architecture:   any
Pre-Depends:    debconf (>= 1.4.30) | debconf-2.0
Depends:        bareos-common (= ${binary:Version}), ${shlibs:Depends}, ${misc:Depends}
Conflicts:      bacula-console
Replaces:       bacula-console
Description: Backup Archiving Recovery Open Sourced - text console
 Bareos is a set of programs to manage backup, recovery and verification of
 data across a network of computers of different kinds.
 .
 The management console allows the administrator or user to
 communicate with the Bareos Director.
 .
 This package provides the text-interface version of the console.


Package:        bareos-client
Architecture:   any
Depends:        bareos-bconsole (>= ${binary:Version}), bareos-filedaemon (>= ${binary:Version}), ${misc:Depends}
Suggests:       bareos-traymonitor
Description: Backup Archiving Recovery Open Sourced - client metapackage
 Bareos is a set of programs to manage backup, recovery and verification of
 data across a network of computers of different kinds.
 .
 The package is a metapackage for client installations (file daemon and
 console).


Package:        bareos-common
Architecture:   any
Pre-Depends:    debconf (>= 1.4.30) | debconf-2.0, adduser, coreutils, findutils, grep, gawk, libc-bin, passwd, openssl, sed
Depends:        ${shlibs:Depends}, ${misc:Depends}
Conflicts:      bacula-director-common, bacula-common
Description: Backup Archiving Recovery Open Sourced - common files
 Bareos is a set of programs to manage backup, recovery and verification of
 data across a network of computers of different kinds.
 .
 This package provides files that are useful for other Bareos packages.


Package:        bareos-database-common
Architecture:   any
Pre-Depends:    debconf (>= 1.4.30) | debconf-2.0
Depends:        bareos-common (= ${binary:Version}), bareos-database-postgresql (= ${binary:Version}), dbconfig-common, lsb-base (>= 3.2-13), ${shlibs:Depends}, ${misc:Depends}
Description: Backup Archiving Recovery Open Sourced - common catalog files
 Bareos is a set of programs to manage backup, recovery and verification of
 data across a network of computers of different kinds.
 .
 This package provides generic abstraction libs and files to connect the Bareos
 Director daemon to a database.


Package:        bareos-database-postgresql
Architecture:   any
Pre-Depends:    debconf (>= 1.4.30) | debconf-2.0
Depends:        dbconfig-pgsql | dbconfig-no-thanks, lsb-base (>= 3.2-13), postgresql-client, ${shlibs:Depends}, ${misc:Depends}
Suggests:       postgresql
Description: Backup Archiving Recovery Open Sourced - PostgreSQL backend
 Bareos is a set of programs to manage backup, recovery and verification of
 data across a network of computers of different kinds.
 .
 This package provides the functionality to connect the Bareos Director
 daemon to a PostgreSQL database.


Package:        bareos-database-tools
Architecture:   any
Pre-Depends:    debconf (>= 1.4.30) | debconf-2.0
Depends:        bareos-common (= ${binary:Version}), bareos-database-common (= ${binary:Version}), lsb-base (>= 3.2-13), ${shlibs:Depends}, ${misc:Depends}
Conflicts:      bacula-sd-mysql, bacula-sd-pgsql, bacula-sd-sqlite3
Description: Backup Archiving Recovery Open Sourced - database tools
 Bareos is a set of programs to manage backup, recovery and verification of
 data across a network of computers of different kinds.
 .
 This package provides tools that requires access to the Bareos database.


Package: bareos-dbg
Architecture: any
Section: debug
Priority: extra
Depends:
    bareos-storage (= ${binary:Version}) | bareos-bconsole (= ${binary:Version}) | bareos-common (= ${binary:Version}) | bareos-database-common (= ${binary:Version}) | bareos-database-postgresql (= ${binary:Version}) | bareos-database-tools (= ${binary:Version}) | bareos-director (= ${binary:Version}) | bareos-filedaemon (= ${binary:Version}) | bareos-storage (= ${binary:Version}) | bareos-storage-tape (= ${binary:Version}) | bareos-storage-fifo (= ${binary:Version}) | bareos-tools (= ${binary:Version}),
    ${misc:Depends}
Conflicts: bacula-sd-dbg, bacula-sd-mysql-dbg, bacula-sd-pgsql-dbg, bacula-sd-sqlite3-dbg
Description: Backup Archiving Recovery Open Sourced - debugging symbols
 Bareos is a set of programs to manage backup, recovery and verification of
 data across a network of computers of different kinds.
 .
 This package provides debugging symbols for Bareos.


Package:        bareos-director
Architecture:   any
Pre-Depends:    debconf (>= 1.4.30) | debconf-2.0, adduser
Depends:        bareos-common (= ${binary:Version}), bareos-database-common (= ${binary:Version}), bareos-database-tools, lsb-base (>= 3.2-13), lsof, bsd-mailx | mailx, ${shlibs:Depends}, ${misc:Depends}
Recommends:     logrotate
Conflicts:      bacula-director
Replaces:       bacula-director
Description: Backup Archiving Recovery Open Sourced - director daemon
 Bareos is a set of programs to manage backup, recovery and verification of
 data across a network of computers of different kinds.
 .
 The Bareos Director service supervises all the backup, restore, verify and
 archive operations. It can run as a daemon or as a foreground service which
 administrators can use to schedule backups and recover files.
 .
 This package contains the Bareos Director daemon.


Package:        bareos-filedaemon
Architecture:   any
Pre-Depends:    debconf (>= 1.4.30) | debconf-2.0, adduser
Depends:        bareos-common (= ${binary:Version}), lsb-base (>= 3.2-13), lsof, ${shlibs:Depends}, ${misc:Depends}
Conflicts:      bacula-fd
Replaces:       bacula-fd, bareos-universal-client
Description: Backup Archiving Recovery Open Sourced - file daemon
 Bareos is a set of programs to manage backup, recovery and verification of
 data across a network of computers of different kinds.
 .
 The file daemon has to be installed on the machine to be backed up. It is
 responsible for providing the file attributes and data when requested by
 the Director, and also for the file system-dependent part of restoration.
 .
 This package contains the Bareos File daemon.


Package:        bareos-storage
Architecture:   any
Pre-Depends:    debconf (>= 1.4.30) | debconf-2.0, adduser
Depends:        bareos-common (= ${binary:Version}), lsb-base (>= 3.2-13), lsof, ${shlibs:Depends}, ${misc:Depends}
Recommends:     bareos-tools
Conflicts:      bacula-sd
Replaces:       bacula-sd
Breaks:         bareos-storage-tape (<< 14.2.6~)
Description: Backup Archiving Recovery Open Sourced - storage daemon
 Bareos is a set of programs to manage backup, recovery and verification of
 data across a network of computers of different kinds.
 .
 The storage daemon performs the storage and recovery of the file
 attributes and data to the physical media; in other words, it is
 responsible for reading and writing the backups.
 .
 It runs on the machine which has access to the backup device(s) - usually
 a tape drive, but alternatively other storage media, such as files.


Package:        bareos-storage-fifo
Architecture:   any
Pre-Depends:    debconf (>= 1.4.30) | debconf-2.0
Depends:        bareos-common (= ${binary:Version}), bareos-storage (= ${binary:Version}), lsb-base (>= 3.2-13), ${shlibs:Depends}, ${misc:Depends}
Description: Backup Archiving Recovery Open Sourced - storage daemon FIFO backend
 Bareos is a set of programs to manage backup, recovery and verification of
 data across a network of computers of different kinds.
 .
 This package contains the Storage backend for FIFO files.
 This package is only required, when a resource "Archive Device = fifo"
 should be used by the Bareos Storage Daemon.


Package:        bareos-storage-dedupable
Architecture:   any
Pre-Depends:    debconf (>= 1.4.30) | debconf-2.0
Depends:        bareos-common (= ${binary:Version}), bareos-storage (= ${binary:Version}), lsb-base (>= 3.2-13), ${shlibs:Depends}, ${misc:Depends}
Description: Backup Archiving Recovery Open Sourced - storage daemon DEDUPABLE backend
 Bareos is a set of programs to manage backup, recovery and verification of
 data across a network of computers of different kinds.
 .
 This package contains the Storage backend for the dedupable storage format.
 This package is only required, when a resource "Archive Device = dedup"
 should be used by the Bareos Storage Daemon.


Package:        bareos-storage-tape
Architecture:   any
Pre-Depends:    debconf (>= 1.4.30) | debconf-2.0, adduser
Depends:        bareos-common (= ${binary:Version}), bareos-storage (= ${binary:Version}), lsb-base (>= 3.2-13), mtx, ${shlibs:Depends}, ${misc:Depends}
Recommends:     mt-st
Suggests:       scsitools, sg3-utils
Breaks:         bareos-storage (<< 14.2.6~)
Replaces:       bareos-storage (<< 14.2.6~)
Description: Backup Archiving Recovery Open Sourced - storage daemon tape support
 Bareos is a set of programs to manage backup, recovery and verification of
 data across a network of computers of different kinds.
 .
 The storage daemon performs the storage and recovery of the file
 attributes and data to the physical media; in other words, it is
 responsible for reading and writing the backups.
 .
 It runs on the machine which has access to the backup device(s) - usually
 a tape drive, but alternatively other storage media, such as files.
 .
 This adds the tape specific support files for the storage daemon.


Package:        bareos-tools
Architecture:   any

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

# Uncomment this to turn on verbose mode.
DH_VERBOSE = 1

# This has to be exported to make some magic below work.
DH_OPTIONS = -v

DAEMON_USER = bareos
DAEMON_GROUP = bareos
DIRECTOR_DAEMON_USER = $(DAEMON_USER)
STORAGE_DAEMON_USER = $(DAEMON_USER)
FILE_DAEMON_USER = root
STORAGE_DAEMON_GROUP = $(DAEMON_GROUP)
BAREOS_VERSION := $(shell dpkg-parsechangelog | egrep '^Version:' | sed 's/Version: //g')

define CONFIGURE_COMMON
  -DDEBUG_PREFIX_MAP:BOOL=OFF \
  -Dsbin-perm=755 \
  -Dsbindir=/usr/sbin \
  -Dbindir=/usr/bin \
  -Dlibdir=/usr/lib/bareos \
  -Dsysconfdir=/etc \
  -Dconfdir=/etc/bareos \
  -Darchivedir=/var/lib/bareos/storage \
  -Dbackenddir=/usr/lib/bareos/backends \
  -Dconfigtemplatedir=/usr/lib/bareos/defaultconfigs \
  -Dscriptdir=/usr/lib/bareos/scripts \
  -Dplugindir=/usr/lib/bareos/plugins \
  -Dworkingdir=/var/lib/bareos \
  -Dbsrdir=/var/lib/bareos \
  -Dlogdir=/var/log/bareos \
  -Dsubsysdir=/var/lock \
  -DSHARE_INSTALL_PREFIX:PATH=/usr/share \
  -Dwebuiconfdir=/etc/bareos-webui \
  -Dreadline=yes \
  -Dbatch-insert=yes \
  -Ddynamic-cats-backends=yes \
  -Ddynamic-storage-backends=yes \
  -Dscsi-crypto=yes \
  -Dlmdb=yes \
  -Dndmp=yes \
  -Dacl=yes \
  -Dxattr=yes \
  -Dpostgresql=yes \
  -Dopenssl=yes \
  -Ddir-user=$(DIRECTOR_DAEMON_USER) \
  -Ddir-group=$(DAEMON_GROUP) \
  -Dsd-user=$(STORAGE_DAEMON_USER) \
  -Dsd-group=$(STORAGE_DAEMON_GROUP) \
  -Dfd-user=$(FILE_DAEMON_USER) \
  -Dfd-group=$(DAEMON_GROUP) \
  -Ddir-password="XXX_REPLACE_WITH_DIRECTOR_PASSWORD_XXX" \
  -Dfd-password="XXX_REPLACE_WITH_CLIENT_PASSWORD_XXX" \
  -Dsd-password="XXX_REPLACE_WITH_STORAGE_PASSWORD_XXX" \
  -Dmon-dir-password="XXX_REPLACE_WITH_DIRECTOR_MONITOR_PASSWORD_XXX" \
  -Dmon-fd-password="XXX_REPLACE_WITH_CLIENT_MONITOR_PASSWORD_XXX" \
  -Dmon-sd-password="XXX_REPLACE_WITH_STORAGE_MONITOR_PASSWORD_XXX" \
  -Dbasename="XXX_REPLACE_WITH_LOCAL_HOSTNAME_XXX" \
  -Dhostname="XXX_REPLACE_WITH_LOCAL_HOSTNAME_XXX" \
  -Dincludes=yes \
  -Drpath=no \
  -DVERSION_STRING=$(BAREOS_VERSION)
endef

ifeq ($(DEB_HOST_ARCH_OS),kfreebsd)
CONFIGURE_COMMON       += -Dacl=no -Dxattr=no -Dscsi-crypto=no -Dndmp=no
endif
ifeq ($(DEB_HOST_ARCH_OS),hurd)
CONFIGURE_COMMON       += -Dscsi-crypto=no -Dndmp=no
endif

override_dh_auto_configure:
ifeq (build-universal-client,$(filter build-universal-client,$(DEB_BUILD_OPTIONS)))
	echo "configuring universal client"
	dh_auto_configure -- $(CONFIGURE_COMMON) -DBUILD_UNIVERSAL_CLIENT=yes
else
	echo "configure full configuration"
	dh_auto_configure -- $(CONFIGURE_COMMON) -Dpython=yes -Dtraymonitor=yes
endif
	cmake --build cmake-build/ -- generate-debian-control


override_dh_fixperms:
	# all files in /etc/bareos
	dh_fixperms \
		--exclude etc/bareos/ \
		--exclude var/lib/bareos/ \
		--exclude var/log/bareos/


override_dh_strip:
ifeq (build-universal-client,$(filter build-universal-client,$(DEB_BUILD_OPTIONS)))
	dh_strip --dbg-package=bareos-universal-client-dbg
else
	dh_strip --dbg-package=bareos-dbg
endif


override_dh_systemd_enable:
ifeq (build-universal-client,$(filter build-universal-client,$(DEB_BUILD_OPTIONS)))
	dh_systemd_enable --name bareos-filedaemon
else
	dh_systemd_enable
endif


override_dh_installinit:
	# Skipped. Only use systemd configuration.


override_dh_systemd_start:
	dh_systemd_start bareos-filedaemon.service --no-start --restart-after-upgrade


override_dh_makeshlibs:
	dh_makeshlibs -n


override_dh_auto_test:
# Only run tests,
# if DEB_BUILD_OPTIONS does not contain nocheck,
# see https://www.debian.org/doc/debian-policy/ch-source.html#s-debianrules-options
# No tabs allowed before ifeq.
ifneq (nocheck,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
	cd cmake-build && ls Testing/*/Test.xml || REGRESS_DEBUG=1 ctest -V -S CTestScript.cmake || echo "ctest result:$?"
else
	@echo "ctest: skipped"
endif


override_dh_shlibdeps:
	dh_shlibdeps -l$(shell pwd)/debian/tmp/usr/lib/bareos


%:
	dh $@ --builddirectory=cmake-build


gen-debian-copyright:
	(cd debian; make copyright)
